use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'PartitionDemo')
	DROP DATABASE PartitionDemo
GO
CREATE DATABASE PartitionDemo
GO
use PartitionDemo
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG1
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG2
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG3
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG4
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG5
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG6
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG7
GO
ALTER DATABASE PartitionDemo
	ADD FILEGROUP FG8
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File1', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file1.ndf') TO FILEGROUP FG1
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File2', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file2.ndf') TO FILEGROUP FG2
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File3', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file3.ndf') TO FILEGROUP FG3
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File4', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file4.ndf') TO FILEGROUP FG4
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File5', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file5.ndf') TO FILEGROUP FG5
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File6', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file6.ndf') TO FILEGROUP FG6
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File7', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file7.ndf') TO FILEGROUP FG7
GO
ALTER DATABASE PartitionDemo
	ADD FILE (name='File8', filename='c:\Program Files\Microsoft SQL Server\MSSQL11.MSSQLSERVER\MSSQL\DATA\file8.ndf') TO FILEGROUP FG8
GO
CREATE PARTITION FUNCTION MyPartFunction (datetime)
AS RANGE LEFT FOR VALUES ('20010101', '20020101', '20030101', '20040101', '20050101', '20060101', '20070101');
GO
CREATE PARTITION SCHEME MyPartSchema
AS PARTITION MyPartFunction
ALL TO ([primary]);
GO
CREATE PARTITION SCHEME MyPartSchema2
AS PARTITION MyPartFunction
TO (FG1, FG2, FG3, FG4, FG5, FG6, FG7, FG8, [PRIMARY]);
GO
CREATE TABLE OrderHistory
(MyId BIGINT IDENTITY(1,1),
OrderDate datetime,
DueDate datetime,
AccountNumber nvarchar(15)
PRIMARY KEY (MyId, OrderDate))
ON MyPartSchema(OrderDate)
GO

CREATE TABLE OrderHistory2
(MyId BIGINT IDENTITY(1,1),
OrderDate datetime,
DueDate datetime,
AccountNumber nvarchar(15)
PRIMARY KEY (MyId, OrderDate))
ON MyPartSchema2(OrderDate)
GO

INSERT INTO OrderHistory 
(OrderDate, DueDate, AccountNumber)
SELECT OrderDate, DueDate, AccountNumber
FROM AdventureWorks2008R2.Sales.SalesOrderHeader
GO
INSERT INTO OrderHistory2
(OrderDate, DueDate, AccountNumber)
SELECT OrderDate, DueDate, AccountNumber
FROM AdventureWorks2008R2.Sales.SalesOrderHeader
GO 110
SELECT *, $Partition.MyPartFunction(OrderHistory.OrderDate) PartitionNumber
FROM OrderHistory 
GO
SELECT OrderDate, DueDate, AccountNumber, $Partition.MyPartFunction(a.OrderDate) PartitionNumber
FROM AdventureWorks2008R2.Sales.SalesOrderHeader a
GO
SELECT MIN(OrderDate), MAX(OrderDate), $Partition.MyPartFunction(a.OrderDate) PartitionNumber
FROM AdventureWorks2008R2.Sales.SalesOrderHeader a
GROUP BY $Partition.MyPartFunction(a.OrderDate)
GO
/*Lets rebuild the index on OrderHistory2 to make DBCC IND easier to read*/
alter index all on dbo.OrderHistory2 rebuild
GO
/*Lets look at where the pages are actually written to*/
DBCC IND ('PartitionDemo', 'OrderHistory2', 1)
GO


DBCC TRACEON (3604, -1)

DECLARE @dbid as int = db_id('PartitionDemo')
--DBCC PAGE (@dbid, 8, 9, 3) --IAM
--DBCC PAGE (@dbid, 8, 1330, 3) --root page (PageType=2, IndexLevel=2)
--DBCC PAGE (@dbid, 8, 1328, 3) --b-tree data (PageType=2, IndexLevel=1)
DBCC PAGE (@dbid, 8, 1649, 3) --page data (PageType=1)

/*Remove the Empty Partitions*/
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20010101')
GO
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20020101')
GO
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20030101')
GO
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20040101')
GO
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20050101')
GO

/*Put everything into a single partition*/
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20060101')
GO
ALTER PARTITION FUNCTION MyPartFunction()
MERGE RANGE ('20070101')
GO

/*Split the data into multiple partitions*/
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060101')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060201')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060301')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060401')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060501')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060601')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO
ALTER PARTITION FUNCTION MyPartFunction()
SPLIT RANGE ('20060701')
GO
ALTER PARTITION SCHEME MyPartSchema NEXT USED [Primary]
ALTER PARTITION SCHEME MyPartSchema2 NEXT USED [Primary]
GO


use master
GO
IF EXISTS (SELECT * FROM sys.databases WHERE name = 'PartitionDemo')
	DROP DATABASE PartitionDemo
GO
